#include "ConversionProviderRS.h"
#include "UpdatableProxyRowsetImpl.h"
#include "IRowsetExactScrollImpl.h"

class CMyDataObject;

class CDataObjectRowset : 
   public CUpdatableProxyRowsetImpl<
      CMyDataObject, 
      CDataObjectRowset, 
      CConversionProviderCommand,
      CRowsetStorageProxy<CDataObjectRowset>, 
      CRowsetArrayTypeProxy<CDataObjectRowset, CRowsetStorageProxy<CDataObjectRowset> >,
      CSimpleRow,
      IRowsetExactScrollImpl < CDataObjectRowset > >
{
   public :

      BEGIN_COM_MAP(CDataObjectRowset)
	      COM_INTERFACE_ENTRY(IRowsetLocate)
	      COM_INTERFACE_ENTRY(IRowsetScroll)
	      COM_INTERFACE_ENTRY(IRowsetExactScroll)
	      COM_INTERFACE_ENTRY_CHAIN(UpdatableProxyRowsetClass)
      END_COM_MAP()

      // CProxyRowsetImpl requires that we implement these...

      virtual void GetColumnInformation(
         size_t column, 
         DBTYPE &dbType, 
         ULONG &size, 
         std::string &columnName, 
         DWORD &flags);

      virtual void GetColumnData(
         size_t row,
         size_t column,
         DBTYPE &dbType, 
         ULONG &size, 
         void *&pData,
         bool &bIsUpdatable);

      virtual size_t GetNumColumns();

      virtual size_t GetNumRows() const;

      virtual HRESULT AddRow();
      virtual HRESULT RemoveRow(int nIndex);

      // CUpdatableProxyRowsetImpl requires this one as well...

      virtual void UpdateColumn(
         size_t row, 
         size_t column, 
         void *pData);

};

